//grid02

//global skills
ifndef grid02_wdl;
define grid02_wdl;

define star_type, skill10;
define sector_name, skill11;

var sector_name_count = 0;
// skill 48 global id

string star_sprite_tga = <star_sprite.tga>;
string roid_mdl = <asteroid01.mdl>;
string roid3_mdl = <roid3.mdl>;
string icon_plate = <icon_plate2.mdl>;

var nodes[1000];
var initloop = 0;
var plate_entities[500]; // control up to 100 different entities
var index = 0;
var counter = 0;

var orbit_var;
var distance_var;

var temp_id;

var gridx0;
var gridx1;
var gridx2;
var gridy0;
var gridy1;
var gridy2;

var grid_index =0;
var temp_index =0;

var grid_length;
var grid_width;
var temp_vector[3];


var temp_planet_array[10];

var init_game01_rndstart = 0;


var init_game01_scenespace = 0;

// entry: Map Grid Length
// help: Define the map grid length.
// id: 2
var init_game01_mapgrid_length = 3;

// entry: Map Grid Width
// help: Define the map grid width.
// id: 2
var init_game01_mapgrid_width = 3;



function run_this()
{
	diag("\ngenerating scenario");
}

function create_plates2()		//create a random grid
{
		diag("\n create_plates2");
	plate_entities[index] = handle (my);
	index += 1;
		// put the rest of your entity code here
	//plate = me;
	my.transparent = on;
	my.alpha = 50;
	my.scale_x = 20;
	my.scale_y = 20;
	my.scale_z = 20;
	my.passable = on;
	my.overlay = on;
	my.light = on;
}

function get_sector_stats(temp)
{
	if(campaign_systems[temp] == 1)
	{
		diag("\nwe have data");
		//we have data
	}
	else
	{
		return(0);
	}
}

function get_sector_name(me)
{
	sector_name_count += 1;
	return(sector_name_count);	
}


function get_grid_id()
{
		diag("\n get_grid_id");
	temp_index = grid_index;
	grid_index += 1;
	return(temp_index);
}


function change_expl_text(me)
{
	if(my.grid_id == 0)
	{
		str_cpy(system_name_txt, name_index.string[my.skill11]);			
		
	}
	else
	{
		str_cpy(system_name_txt, name_index.string[my.skill11]);			
		
	}
	
}



//--------------------------------------------------------------------------
function plate_events()
{
		//diag("\n triggering plate events");
//	temp_id = my.grid_id;
//	temp_ptr = ptr_for_handle(plate_entities[temp_id]);
	if(EVENT_TYPE == event_touch)
	{
		change_expl_text(me);
		context_location = my.grid_id;
		my.alpha += 50;
		
	}

	if(EVENT_TYPE == event_release)
	{
		//my.alpha -= 90;
		//my.invisible = off;
		my.alpha -= 50;
		
	}
	if (EVENT_TYPE == event_click)
	{
		zoom_on_me(me);
		
	}
	if(EVENT_TYPE == EVENT_Scan)
	{
			

	}
	if(EVENT_TYPE == EVENT_DETECT)
	{
		diag("\n trace");
		set_detect(you);
		
	}
	
}

function get_star_type()
{
	var star_type_var;
	star_type_var = int(random(70));
	if(my.grid_id == 0)
	{
		return(1);
	}
	if(star_type_var > = 0 && star_type_var <= 35)
	{
//		diag("\nyellow_star");
		temp = 1;
		return(temp);
	}
	if(star_type_var > 35 && star_type_var <= 50)
	{
//		diag("\nred_dwarf");
		temp = 2;
		return(temp);
	}
	if(star_type_var > 50 && star_type_var <= 60)
	{
//			diag("\nred_giant");
		temp = 3;
		return(temp);
	}
	if(star_type_var > 60 && star_type_var <= 65)
	{
//			diag("\nblue_giant");
		temp = 4;
		return(temp);
	}
	if(star_type_var > 65 && star_type_var <= 67)
	{
//			diag("\nsuper_giant");
		temp = 5;
		return(temp);
	}
	if(star_type_var > 67 && star_type_var <= 68)
	{
//			diag("\nbinary");
		temp = 6;
		return(temp);
	}
	if(star_type_var > 68)
	{
//			diag("\nblack_hole");
		temp = 7;
		return(temp);
	}
}	

string this_grid[10];

//-------------------------------------------------------------------------
function plate()		//create scenario grid
{

	index += 1;
	plate_ent = me;
	
	var my_centre[3];
	var colors_pos[3];


	diag("\n create plate");
//	
	my.overlay = on;
	my.transparent = on;
	my.alpha = 50;
	
	my.scale_x = 40;
	my.scale_y = 40;
	my.scale_z = 40;
	my.passable = on;
	c_setminmax(me);

	my.grid_id = get_grid_id(); //skill 1
	
	my.skill10 = get_star_type();	//skill 10

	my.skill11 = get_sector_name(me);	//skill 11

	my.selected = off;
	my.detected = off;
	my.invisible = on;
	my.explored = off;
	
	my.enable_touch = on;
	my.enable_scan = on;
	my.enable_click = on;
	my.enable_release = on;
	my.enable_detect = on;
	my.event = plate_events;
//	
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	
	my_centre.x = my.skill2;
	my_centre.y = my.skill3;
	my_centre.z = my.skill4;
	
	
	//while(my.detected == off && my.invisible == on) // if no detection  -  wait
	while(my.detected == off)
	{
		//my.invisible = on;
		wait(1);
	}
	
	
	
	// once I'm detected - create my planets from from my grid id
	if(my.skill10 == 0)		// no star
	{
		ent_create(dummy02_mdl,my_centre,star_yellow);		//but we'll put one there for now
		//wait(1);
	}
	if(my.skill10 == 1)
	{
		ent_create(dummy02_mdl,my_centre,star_yellow);
		//wait(1);
	}
	if(my.skill10 == 2)
	{
		ent_create(dummy02_mdl,my_centre,star_reddwarf);
		
	}
	if(my.skill10 == 3)
	{
		ent_create(dummy02_mdl,my_centre,star_redgiant);
		//wait(1);
	}
	if(my.skill10 == 4)
	{
		ent_create(dummy02_mdl,my_centre,star_blugiant);
		
	}
	if(my.skill10 == 5)
	{
		ent_create(dummy02_mdl,my_centre,star_supgiant);
		//wait(1);
	}
	if(my.skill10 == 6)
	{
		ent_create(dummy02_mdl,my_centre,star_supgiant);		//change to binary
		
	}
	if(my.skill10 == 7)
	{
		ent_create(dummy02_mdl,my_centre,blackhole);
	}
	var temp_entry;
	// done with stars - create planets
	//criteria
	//first check if my.grid_id has an entry
	//if no entry - create a random system based on star type
	temp_entry = get_sector_stats(my.grid_id);
	var number_planets;
	
	if(temp_entry == 0)
	{
		diag("\n no data - generate randomly");
		//generate randomly
		if(my.skill10 == 1)
		{
			diag("\n yellow star");	// number of planets between 4 and 12
			number_planets = int(random(8) + 4);
		}
		if(my.skill10 == 2)
		{
			diag("\n red dwarf");	//number of planets between 4 and 9
			number_planets = int(random(6) + 3);
		}
		if(my.skill10 == 3)
		{
			diag("\n redgiant");	//number of planets between 3 and 7
			number_planets = int(random(5) + 2);
		}
		if(my.skill10 == 4)
		{
			diag("\n blugiant");		//number of planets between 5 and 8
			number_planets = int(random(4) + 4);
		}
		if(my.skill10 == 5)
		{
			diag("\n supergiant");	// number of planet between 3 and 4
			number_planets = int(random(1) + 3);
		}
		if(my.skill10 == 6)
		{
			diag("\n super giant");// same as above
			number_planets = int(random(1) + 3);
		}
		if(my.skill10 == 7)
		{
			diag("\n black_hole");	// no planets
		}
	}
	if(temp_entry == 1)
	{
		//get my number of planets and types from array
	
		get_sector_planets(me);
	}
	
	
	while(1)
	{
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = on;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = on;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = on;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = off;
			
			}
	}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}

////	
}

//-------------------------------------------------------------------------
function advance_counter()
{
	counter += 1;
		diag("\n advance_counter");
}

function reset_counter()
{
		diag("\n reset_counter");
	counter = 0;
}

function advance_grid(initloop)
{
		diag("\n advance_grid");
	if(initloop == 0)
	{
		gridx0 = 0;
		gridy0 = 0;
	}
	if(initloop >= 8)
	{
		gridx0 = 7680;
		gridy0 = 7680;
	}
	if(initloop >= 16)
	{
		gridx0 = 7680;
		gridy0 = 0;
	}
	if(initloop >= 24)
	{
		gridx0 = 7680;
		gridy0 = -7680;
	}
	//if(initloop >= 9 && initloop >= 18 && initloop >= 27)
	if(initloop >= 32)
	{
		gridx0 = 0;
		gridy0 = -7680;
	}
	if(initloop >= 40)
	{
		gridx0 = -7680;
		gridy0 = -7680;
	}
	if(initloop >= 48)
	{
		gridx0 = -7680;
		gridy0 = 0;
	}
	if(initloop >= 56)
	{
		gridx0 = -7680;
		gridy0 = 7680;
	}	
	if(initloop >= 64)
	{
		gridx0 = 0;
		gridy0 = 7680;
	}
	//		if(initloop >= 81)
	//	{
		//		gridx0 = 0;
		//		gridy0 = 192;
		//		gridx1 = gridx0 + 64;
		//		gridx2 = gridx0 - 64;
		//		gridy1 = gridy0 + 64;
		//		gridy2 = gridy0 - 64;
	//	}
}

function get_vector_pos(initloop)
{
	var total_grid;
	grid_length = init_game01_mapgrid_length * 3;
	grid_width = init_game01_mapgrid_width * 3;
		diag("\n get_vector_pos");
	total_grid = ((grid_length * grid_width)-1);
	if(initloop  <= total_grid)
	{
		gridx1 = gridx0 + 2560;
		gridx2 = gridx0 - 2560;
		gridy1 = gridy0 + 2560;
		gridy2 = gridy0 - 2560;
		if(counter == 0)
		{
			vec_set(temp_vector, vector(gridx0,gridy0,0));
			
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 1)
		{
			vec_set(temp_vector, vector(gridx1,gridy1,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 2)
		{
			vec_set(temp_vector, vector(gridx1,gridy0,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 3)
		{
			vec_set(temp_vector, vector(gridx1,gridy2,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 4)
		{
			vec_set(temp_vector, vector(gridx0,gridy2,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 5)
		{
			vec_set(temp_vector, vector(gridx2,gridy2,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 6)
		{
			vec_set(temp_vector, vector(gridx2,gridy0,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 7)
		{
			vec_set(temp_vector, vector(gridx2,gridy1,0));
			advance_counter();
			return(temp_vector);	// create player homeworld plate
		}
		if(counter == 8)
		{
			vec_set(temp_vector, vector(gridx0,gridy1,0));
			reset_counter();
			advance_grid(initloop);
			return(temp_vector);	// create player homeworld plate
		}
	}
}	

var set_vis = 0;



function create_allsystems(initloop)
{
	if (init_game01_rndstart == 0)
	{
		//	diag("\ncreating random sectors");
		temp_vector = get_vector_pos(initloop);
		ent_create(icon_plate,temp_vector,plate);	
			diag("\n creating systems and sectors");
	}
	if (init_game01_rndstart  == 1)
	{
		//		diag("\n creating scenario");
		temp_vector = get_vector_pos(initloop);
		//create_scenario(initloop,temp_vector);
		ent_create(icon_plate,temp_vector,create_plates2);
		
	}
//	diag("\n zap");
}


//Desc:  Initiate Nodes - Generates the map grid using length and width
function init_nodes()

{
	grid_length = init_game01_mapgrid_length * 3;
	grid_width = init_game01_mapgrid_width * 3;
	//wait(4);
	initloop = 0;
	while
	(initloop < (grid_length * grid_width) +1)
	{
		//		diag("\ninitloop");
		
		nodes[initloop] = 0;
		create_allsystems(initloop);
		
		
		initloop += 1;
	}
		diag("\ndonelooping");
		//wait(30);
}


function turn_off_else()
{
	beep();
//			you = ent_next (NULL); // retrieve first entity
// 		while (you != NULL) // repeat until there are no more entities
//		{ 
//	
//	
//			if(you == plate)
//			{
//				your.invisible = on;
//				while(cutscene_on == 1)
// 			{
// 				wait(1);
// 			}
//			}
// 			you = ent_next (you); // get next entity
// 			while(cutscene_on == 1)
// 			{
// 				wait(1);
// 			}
 			
// 	}
}


endif;