//planets
ifndef planets01_wdl;
define planets01_wdl;

var name_counter;
var build_options_var = 0;
string ring_sprite_tga = <ring_sprite.tga>;
string ring_sprite_pcx = <ring_sprite.pcx>;
string moon_sprite_tga = <moon_sprite.tga>;

var data_earth = 1;
var data_mars = 0;

var options_pan_on = 0;

function update_my_population(me)
{
	my.skill21 = my.skill21 * 1.5;
	my.skill26 = my.skill21 * 0.01;
//	var temp_population;
//	var current_population;
//	current_population = my.skill21;
//	if(temp_population != current_population)
//	{
//		my.skill21 += current_population - temp_population;
//	}
}

string number_string;
var stay_on_display = 0;

function change_planet_text(me)
{
	if(my.selected == 0)			// show me, but turn me off if i'm not selected
	{
		str_cpy(planet_name_txt, planet_name_index.string[my.skill50]);
		//str_cpy(description_holder, desc_planet_terran)	;	
	}
	if(my.selected == 1)
	{
		while(1)
		{
			str_cpy(planet_name_txt, planet_name_index.string[my.skill50]);
			
			wait(1);
		}
	}
}

function get_planet_name(me)
{
	//var temp_name_id;
	name_counter += 1;
	//get the next name from the list
	return(name_counter);
}

function build_options_display(me)
{
	while(my.selected == on && my.flag4 == 1)		//i'm selected and i'm a homeworld
	{
		options_pan_on = 1;
		build_options_display_h_pan.visible = on;
		wait(1);
	}
	while(my.selected == on && my.flag4 == 0 && my.skill68 == 1)
	{
		options_pan_on = 1;
		build_options_display_c_pan.visible = on;
		wait(1);
	}
	while(my.selected == on && my.flag4 == 0 && my.skill68 == 2)
	{
		options_pan_on = 1;
		build_options_display_e_pan.visible = on;
		wait(1);
	}
		options_pan_on = 0;
		build_options_display_h_pan.visible = off;
		build_options_display_c_pan.visible = off;
		build_options_display_e_pan.visible = off;

	
}
//
function population_display(me)
{
	while(my.selected == on)
	{
			planet_population_pan.visible = on;
			planet_population_var = my.skill21;
			planet_energyoutput_var = my.skill26;
			wait(1);
	}
	planet_population_pan.visible = on;
	planet_population_var = my.skill21;
	planet_energyoutput_var = my.skill26;
	
}

string = selected_object[30];

function select_object()
{
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(you == mouse_ent)
		{
			your.selected = on;
			
		}
		else
		{
			your.selected = off;
		}
 		you = ent_next (you); // get next entity
 			
 	}

}

function build_colony_here(you)
{
	//population -= 10;
	your.skill21 += 1;
	your.skill69 = 1;
	//mouse_map = arrow;
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag4 == on)
		{
			your.skill21 -= 1;		//send 1 pop unit (1 million people) off the homeworld
			energy -=	100;
		}
 		you = ent_next (you); // get next entity
 			
 	}
}

function build_orbital_here(you)
{
	//population -= 10;
	//my.skill21 += 1;
	wait(1);
	ent_create(space_bldr_mdl, your.x, builders_func);
	
	your.skill69 = 1;
	mouse_map = arrow;
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag4 == on)
		{
			//your.skill21 -= 1;		//send 1 pop unit (1 million people) off the homeworld
			energy -= 200;
			//your.skill26 -=	200;
		}
 		you = ent_next (you); // get next entity
 			
 	}
}

function planet_events()
{
	if(EVENT_TYPE == event_touch)
	{
		population_display(me);
		context_location = my.grid_id;	
	}

	if(EVENT_TYPE == event_release)
	{
	}
	if (EVENT_TYPE == event_rightclick)
	{
		diag("\n check_loop");
		
		select_object();
		change_planet_text(me);
		change_expl_text(me);
		population_display(me);
		
		zoom_on_me(me);
		planet_cam_on_me(me);
		
		build_options_display(me);	
	}
	if(EVENT_TYPE == EVENT_Scan)
	{
		if(you == probe_ent)
		{
//			diag("\nyou is probe");
//			your.invisible = on;
		}
	}
	if(EVENT_TYPE == EVENT_DETECT)
	{
		set_detect(you);
	}
	
}



function gas_md
{
	gas_md_ent = me;
	
	my.grid_id = your.grid_id;
	
	my.scale_x = 0.8;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
		c_setminmax(me);

	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	
	var scan_range;
	var scan_temp[3];
	var detect_temp;
	
//	my.cast = on;
//	my.shadow = on;
//	my.light = on;
	
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.skill11 = your.skill11;
	
	my.skill50 = get_planet_name(me);
	
	my.skill16 = 950; // orbit distance
	my.skill17 = 0.01; 
	
	my.skill18 = 12; // number of moons

	my_orbit = random(360);
	my_distance = my.skill16;
	
	
	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);
	
	my.skill2 = my.x;
	my.skill3 = my.y;
	
	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
//	if(my.grid_id == 0)
//	{
//		ent_morphskin(me,skn_giant02_pcx);
//	}
		ent_morphskin(me,skn_giant02_pcx);
	
	while(my.detected == off)
	{
		wait(1);
	}
	//create_moons(me);

		while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10) + random(20) +10;
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10)+random(20) +10;
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			//wait(1);
		}
	
		
//	}
	
//	planet_scan_loop(me);
	

	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
	}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}


}


function gas_lg
{
	
	gas_lg_ent = me;
	
	my.grid_id = your.grid_id;
		
	my.scale_x = 1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
		c_setminmax(me);

	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.skill50 = get_planet_name(me);
	my.skill11 = your.skill11;
	
	my.skill16 = 850; // orbit distance
	my.skill17 = 0.01; 
	
	my.skill18 = 12; // number of moons

	my_orbit = random(360);
	my_distance = my.skill16;
	
	
	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);
	
	my.skill2 = my.x;
	my.skill3 = my.y;
	
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
//	if(my.grid_id == 0)
//	{
		ent_morphskin(me, skn_giant03_pcx);
//	}
	while(my.detected == off)
	{
		wait(1);
	}
	
	while(my_moon_number < my.skill18)
	{
		moon_vector.x = (your.scale_x * 10) + random(20) +10;
		moon_vector.y = moon_vector.x;
		moon_vector.z = (your.scale_x * 10)+random(20) +10;
		ent_create(dummy02_mdl,moon_vector,moon);
		my_moon_number += 1;
			//wait(1);
	}
	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
	}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}

}

function rings()
{
	//my.grid_id = your.grid_id;
	my.overlay = on;
	my.transparent = on;
	my.alpha = 75;
	my.bright = on;
	my.flare = on;
	my.tilt = 95;	
	//my.cast = on;
		my.scale_x = 0.5;
		my.scale_y = my.scale_x;
		my.scale_z = my.scale_x;
	
	//my.roll = 90;
	while(1)
	{
		//my.tilt += 1 * time;
		
		//diag("\ntesting rotation");
		
		if(your.invisible == on)
		{
			
			my.invisible = on;
		}
		if(your.invisible == off)
		{
		//my.tilt += 1 * time;
			
			my.invisible = off;
		}	
		wait(1);
//		//my.invisible = off;
//		
	}
}

function gas_ringed
{
	//gas_giant_ent = me;
	gas_ringed_ent = me;
	
	my.grid_id = your.grid_id;
	
	
	my.scale_x = 1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
	
		c_setminmax(me);

	
	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	
	var scan_range;
	var scan_temp[3];
	var detect_temp;
	
	my.cast = on;
	my.shadow = on;
	//my.light = on;
	
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.skill50 = get_planet_name(me);
	//my.skill50 = 0;	//my name id
	my.skill11 = your.skill11;
	
	my.skill16 = 750; // orbit distance
	my.skill17 = 0.01; 
	
	my.skill18 = 12; // number of moons
	
	my_orbit = random(360);
	my_distance = my.skill16;
	if(my.grid_id == 0)
	{
		my.x = -750;
		my.y = -100;
	}
	else
	{
		my.x = my_centre.x - fcos(my_orbit,my_distance);
		my.y = my_centre.y - fsin(my_orbit,my_distance);
	}

	

	
	my.skill2 = my.x;
	my.skill3 = my.y;
	
	ent_create(ring_sprite_pcx,my.x,rings);
	
//	if(my.grid_id == 0)
//	{
		ent_morphskin(me,skn_giant04_pcx);
//	}
	
	//ent_create(nebula_01_mdl, my.x, nebula_yellow);
	wait(1);
	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	
	while(my.detected == off)
	{
		wait(1);
	}

	while(my_moon_number < my.skill18)
	{
		moon_vector.x = (your.scale_x * 10) + random(20) +10;
		moon_vector.y = moon_vector.x;
		moon_vector.z = (your.scale_x * 10)+random(20) +10;
		ent_create(dummy02_mdl,moon_vector,moon);
		my_moon_number += 1;
			//wait(1);
	}
	
		
//	}
	
//	planet_scan_loop(me);
	

while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
	}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}

}


function gas_giant
{
	gas_giant_ent = me;
	
	my.grid_id = your.grid_id;
	
	
	my.scale_x = 2;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
		c_setminmax(me);

	
	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	
	
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	
	my.skill50 = get_planet_name(me);	//my name id
	//my.system_name = your.system_name;
	
	my.skill11 = your.skill11;
	
	
	my.skill16 = 600; // orbit distance
	my.skill17 = 0.01; 
	
	my.skill18 = 12; // number of moons
	
	my_orbit = random(360);
	my_distance = my.skill16;
	my.invisible = off;
	
	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
		if(your.grid_id == 0)
	{
		ent_morphskin(me, skn_giant01_pcx);
		//my.material = mat_gas_03_blu;
		
		diag("\nearth again");
		my.x = -600;
		my.y = -400;
	}
	else
	{
		ent_morphskin(me,skn_giant02_pcx);
		//my.material = mat_gas_03_blu;
		my.x = my_centre.x - fcos(my_orbit,my_distance);
		my.y = my_centre.y - fsin(my_orbit,my_distance);
		
	}
 	
	
	
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	while(my.detected == off)
	{
		wait(1);
	}

		while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10) + random(20) +10;
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10)+random(20) +10;
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
	
		
		while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
		}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				if(my.skill69 == 1)
			{
				player_colors_ent.invisible = on;
			
			}
	}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}


}




function molten_sm
{
	molten_sm_ent = me;
	
	
	my.grid_id = your.grid_id;
	
	while(player == null){wait(1);
	}
	
	my.scale_x = 0.25;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
	
		c_setminmax(me);

	
	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	
	my.invisible = on;
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = get_planet_name(me);;	//my name id
	//my.system_name = your.system_name;
	my.skill11 = your.skill11;
	
	my.skill16 = 40; // orbit distance
	my.skill17 = 0.09; 
	
	my.skill18 = 0; // number of moons
	
	my_orbit = random(360);
	my_distance = my.skill16;
	ent_morphskin(me,skn_crust02_pcx);
	
	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
 	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);

	
	my.skill2 = my.x;
	my.skill3 = my.y;
	
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
//	if(my.grid_id == 0)
//	{
		ent_morphskin(me,skn_molten_sm01_pcx);
//	}
	
	while(my.detected == off)
	{
		wait(1);
	}

	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
		
	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}	
			
		}
		wait(1);		
	}
}

function molten_md
{
	molten_md_ent = me;
	
	my.grid_id = your.grid_id;
	while(player == null){wait(1);
	}
	var colors_pos[3];
	my.scale_x = 0.65;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
	
		c_setminmax(me);

	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	my.invisible = off;
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = get_planet_name(me);;	//my name id
	//my.system_name = your.system_name;
	my.skill11 = your.skill11;
	
	my.skill16 = 80; // orbit distance
	//my.skill17 = 0.01; 
	
	my.skill18 = int(random(2)); // number of moons
	
	my_orbit = random(360);
	my_distance = my.skill16;
	ent_morphskin(me,skn_crust02_pcx);
	
//	if(my.grid_id == 0)
//	{
		ent_morphskin(me,skn_molten_md01_pcx);
//	}
	
	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
 	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);

	
	my.skill2 = my.x;
	my.skill3 = my.y;
	
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	my.skill68 = 2;
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 5;
	
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);
	you.parent_handle = handle(me);
	while(my.detected == off)
	{
		wait(1);
	}

	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
		
while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;			
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}


}

function terran_md()
{
	terran_md_ent = me;
	
	my.grid_id = your.grid_id;
	while(player == null){wait(1);
	}
	
	my.scale_x = 0.75;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
	
		c_setminmax(me);

	
	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	var colors_pos[3];
	
	var scan_temp[3];
	var scan_source[3];
	
	my.invisible = on;
	
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = 0;	//my name id
	my.skill11 = your.skill11;
	//my.system_name = your.system_name;
	
	my.skill16 = 250; // orbit distance
	my.skill17 = 0.2; 
	
	my.skill18 = int(random(3)); // number of moons
	
	my.skill20 = 15000; 	//max population
	my.skill25 = 15000;	//max energy output
	my_orbit = random(360);
	my_distance = my.skill16;
	
	ent_morphskin(me,skn_terran01_pcx);
	
	if(my.grid_id == 0)
	{
		my.skill50 = get_planet_name(me);	//my name id
		my.skill21 = 10000;	//current population;
		my.skill26 = 0;	//starting surplus
		my.detected = on;
		my.flag4 = 1;		//i'm the homeworld
		my.skill69 = 1;	//occupied by team one;
		my.skill33 = 1000;		//starting scan range
		my.skill39 = 5000;		//starting communication range
		my.skill18 = 1;			
		my.x = -250;
		my.y = -10;
		ent_morphskin(me,skn_terran01_pcx);
		
	}
	else
	{
		my.skill68 = 1;			//1 means i can support a colony || 2 means i can support orbitals 
		
		my.x = my_centre.x - fcos(my_orbit,my_distance);
		my.y = my_centre.y - fsin(my_orbit,my_distance);
		
	}
	
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 1;
	
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);
	you.parent_handle = handle(me);

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			you = ent_create(dummy02_mdl,moon_vector,moon);
			you.parent_handle = handle(me);
			my_moon_number += 1;
			wait(1);
		}
		
	while(me != null)
	{
		while(my.detected == off)
			{
				wait(1);
			}
		if(my.flag4 == on)
		{
			scan_temp.x = 360;
			scan_temp.y = 360;
			scan_temp.z = my.skill33;
				
			scan_source.x = my.x;
			scan_source.y = my.y;
			scan_source.z = my.z;
			scan_entity(scan_source,scan_temp);

		}

		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			if(my.detected == on)
			{
				my.invisible = off;
			}
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}
		}
		wait(1);
	}

}


function barren_md
{
	barren_md_ent = me;
	
	
	my.grid_id = your.grid_id;
	while(player == null){wait(1);
	}
	
	my.scale_x = 0.75;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
		c_setminmax(me);

	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	var colors_pos[3];
	my.invisible = off;
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = get_planet_name(me);	//my name id
	//my.system_name = your.system_name;
	my.skill11 = your.skill11;
	
	my.skill16 = 80; // orbit distance
	my.skill17 = 0.01; 
	
	my.skill18 = int(random(2)); // number of moons
	
	my.skill20 = 15000; 	//max population
	my.skill21 = 0;	//current population;
	
	my.skill69 = 0;
	my.skill68 = 1;			//1 means i can support a colony || 2 means i can support orbitals 
	
	my_orbit = random(360);
	my_distance = my.skill16;
	
	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
 	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);

	ent_morphskin(me,skn_crust02_pcx);
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 1;
	
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);
	you.parent_handle = handle(me);
	
	while(my.detected == off)
	{
		wait(1);
	}
	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
		
	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
			}
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}

//
}

function barren_lg
{
	barren_lg_ent = me;
	
	my.grid_id = your.grid_id;
	while(player == null){wait(1);
	}
	
	my.scale_x = 1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
	
	
		c_setminmax(me);

	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	var colors_pos[3];
	
	my.invisible = on;
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = get_planet_name(me);	//my name id
	//my.system_name = your.system_name;
	
	my.skill16 = 400; // orbit distance
	my.skill17 = 0.1; 
	
	my.skill18 = int(random(2)); // number of moons
	
	my_orbit = random(360);
	my_distance = my.skill16;
	ent_morphskin(me,skn_crust02_pcx);
	
	my.skill69 = 0;		//no occupation
	my.skill68 = 1;			//1 means i can support a colony || 2 means i can support orbitals 

	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
	
	if(my.grid_id == 0)
	{
		my.skill18 = 2;
		my.x = -400;
		my.y = -250;
		//my.skill69 = 1;				//occupied by team one;
	}
	else
	{
		my.skill18 = int(random(2)); // number of moons
	
		
	}
	
 	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);

	
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	
	
	my.skill11 = your.skill11;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 5;
	
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);
	you.parent_handle = handle(me);	
	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	while(my.detected == off)
	{
		wait(1);
	}
	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
		
	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}
}


function frozen_sm
{
	frozen_sm_ent = me;
	
	my.grid_id = your.grid_id;
	while(player == null){wait(1);
	}
	
	my.scale_x = 0.5;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_y;
		c_setminmax(me);

	
	var my_moon_number;
	var moon_vector[3];
	var my_distance;
	var my_orbit;
	var my_centre[3];
	var colors_pos[3];
	my.invisible = off;
	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	
	my.detected = off;
	
	my.skill50 = get_planet_name(me);;	//my name id
	//my.system_name = your.system_name;
	
	
	my.skill11 = your.skill11;
	
	my.skill16 = 1100; // orbit distance
	//my.skill17 = 0.01; 
	
	my.skill18 = int(random(2)); // number of moons
	
	my.skill68 = 2;			//1 means i can support a colony || 2 means i can support orbitals 
	
	
	my_orbit = random(360);
	my_distance = my.skill16;
	ent_morphskin(me,skn_crust02_pcx);
	
	///my.x = random(360);
	//my.y = random(360);
	//my.invisible = on;
 	my.x = my_centre.x - fcos(my_orbit,my_distance);
	my.y = my_centre.y - fsin(my_orbit,my_distance);

	
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	

	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.event = planet_events;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 1;
	
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);
	you.parent_handle = handle(me);
	
	if(my.grid_id == 0)
	{
		if(my.skill50 == 9)
		{
			ent_morphskin(me,skn_frozen01_pcx);
		}
		if(my.skill50 == 10)
		{
			ent_morphskin(me,skn_frozen02_pcx);
		}
		
	}
	
	while(my.detected == off)
	{
		wait(1);
	}

	
	while(my_moon_number < my.skill18)
		{
			
			moon_vector.x = (your.scale_x * 10);
			moon_vector.y = moon_vector.x;
			moon_vector.z = (your.scale_x * 10);
			ent_create(dummy02_mdl,moon_vector,moon);
			my_moon_number += 1;
			wait(1);
		}
		
	while(1)
	{
		my.pan -= my.skill17 * time;
		
		if(cam_dist == zoom_distance1)
		{
			if(my.detected == on)
			{
				my.invisible = off;
				
			}
			
		}
		if(cam_dist == zoom_distance2)
		{
			//show my colors -- who is occupying me
			if(my.detected == on)
			{
				my.invisible = off;
			}
			
			
		}
		if(cam_dist == zoom_distance3)
		{
			//my.invisible = on;
			if(my.detected == on)
			{
				my.invisible = off;
				
			}
		}
		if(cam_dist == zoom_distance4)
		{
			if(my.detected == on)
			{
				my.invisible = on;
			}	
			
		}
//	
		wait(1);
//		//my.invisible = off;
//		
	}


}

endif;